<?php

namespace Ipqualityscore\Ipqualityscore\Events\Observer;

use Magento\Framework\Event\ObserverInterface;
use Psr\Log\LoggerInterface;

class LoadPage implements ObserverInterface
{
    protected $logger;
    protected $scopeConfig;

    public function __construct(LoggerInterface $logger, \Magento\Framework\App\RequestInterface $request, \Magento\Framework\View\Page\Config $pageConfig,  \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig)
    {
        $this->logger = $logger;
        $this->_request = $request;
        $this->_page = $pageConfig;
        $this->scopeConfig = $scopeConfig;
    }

    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        try {

            require_once dirname(__FILE__) . '/../../Integration.php';
            $isAuthed = $this->scopeConfig->getValue('ipqualityscore/general/auth_token', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            if ($isAuthed) {
                $blockAll = $this->scopeConfig->getValue('ipqualityscore/general/block_all', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
                $blockVpn = $this->scopeConfig->getValue('ipqualityscore/general/block_vpn', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
                $blockTor = $this->scopeConfig->getValue('ipqualityscore/general/block_tor', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
                $strictness = $this->scopeConfig->getValue('ipqualityscore/general/strictness', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
                $allowPublic = $this->scopeConfig->getValue('ipqualityscore/general/allow_public', \Magento\Store\Model\ScopeInterface::SCOPE_STORE) ? true : false;
                $allowCrawlers = $this->scopeConfig->getValue('ipqualityscore/general/allow_crawlers', \Magento\Store\Model\ScopeInterface::SCOPE_STORE) ? true : false;
                $blockScore = $this->scopeConfig->getValue('ipqualityscore/general/block_score', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
                $redirect = $this->scopeConfig->getValue('ipqualityscore/general/redirect', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
                $deviceTracking = $this->scopeConfig->getValue('ipqualityscore/general/enable_device_order', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
                $client = new \IpqualityScore\Integration($isAuthed, 'magentov2');
                $response = $client->validateProxy($strictness, $allowPublic);
                if (!$response->cached) {
                    $response->valid_billing_address = '';
                    $response->valid_shipping_address = '';
                    $response->valid_billing_email = '';
                    $response->valid_shipping_email = '';
                    $response->risky_billing_phone = '';
                    $response->risky_shipping_phone = '';
                    $response->fraudulent_behaviour = '';
                    $response->risky_username = '';
                    $response->bin_country = '';
                    $response->valid_billing_phone = '';
                    $response->valid_shipping_phone = '';
                    $response->proxy = $response->proxy ? 1 : 0;
                    $response->vpn = $response->vpn ? 1 : 0;
                    $response->tor = $response->tor ? 1 : 0;
                    $response->recent_abuse = $response->recent_abuse ? 1 : 0;
                    $response->bot_status = $response->bot_status ? 1 : 0;
                    $response->mobile = $response->mobile ? 1 : 0;
                    $response->is_crawler = $response->is_crawler ? 1 : 0;



                    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
                    try {
                        $connection = $resource->getConnection();
                        $sql = "INSERT INTO ipqualityscore_proxy () VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                        $query = $connection->prepare($sql);
                        $query->bindParam(1, $response->fruad_score);
                        $query->bindParam(2, $response->proxy);
                        $query->bindParam(3, $response->ISP);
                        $query->bindParam(4, $response->organization);
                        $query->bindParam(5, $response->ASN);
                        $query->bindParam(6, $response->host);
                        $query->bindParam(7, $response->country_code);
                        $query->bindParam(8, $response->city);
                        $query->bindParam(9, $response->region);
                        $query->bindParam(10, $response->is_crawler);
                        $query->bindParam(11, $response->latitude);
                        $query->bindParam(12, $response->longitude);
                        $query->bindParam(13, $response->timezone);
                        $query->bindParam(14, $response->vpn);
                        $query->bindParam(15, $response->tor);
                        $query->bindParam(16, $response->recent_abuse);
                        $query->bindParam(17, $response->bot_status);
                        $query->bindParam(18, $response->mobile);
                        $query->bindParam(19, $response->operating_system);
                        $query->bindParam(20, $response->browser);
                        $query->bindParam(21, $response->device_model);
                        $query->bindParam(22, $response->device_brand);
                        $query->bindParam(23, $response->valid_billing_address);
                        $query->bindParam(24, $response->valid_shipping_address);
                        $query->bindParam(25, $response->valid_billing_email);
                        $query->bindParam(26, $response->valid_shipping_email);
                        $query->bindParam(27, $response->risky_billing_phone);
                        $query->bindParam(28, $response->risky_shipping_phone);
                        $query->bindParam(29, $response->fraudulent_behaviour);
                        $query->bindParam(30, $response->bin_country);
                        $query->bindParam(31, $response->risky_username);
                        $query->bindParam(32, $response->valid_billing_phone);
                        $query->bindParam(33, $response->valid_shipping_phone);
                        $query->bindParam(34, $response->request_id);
                        $query->execute();
                    } catch (\PDOException $e) {
                        die(print_r($e->getMessage()));
                    }
                }

                if ($response->vpn && ($blockAll || $blockVpn)) {
                    if ($allowCrawlers && $response->is_crawler) {
                    } else {
                        if ($redirect) {
                            header("Location: {$redirect}");
                        }
                    }
                    die();
                }

                if ($response->tor && ($blockAll || $blockTor)) {
                    if ($allowCrawlers && $response->is_crawler) {
                    } else {
                        if ($redirect) {
                            header("Location: {$redirect}");
                        }
                    }
                    die();
                }

                if ($response->proxy &&  $blockAll) {
                    if ($allowCrawlers && $response->is_crawler) {
                    } else {
                        if ($redirect) {
                            header("Location: {$redirect}");
                        }
                    }
                    die();
                }

                if ($blockScore && ($blockScore <= $response->fraud_score)) {
                    if ($allowCrawlers && $response->is_crawler) {
                        if ($redirect) {
                            header("Location: {$redirect}");
                        }
                    }
                    die();
                }
            }

            /*
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $customerSession = $objectManager->get('Magento\Customer\Model\Session');
        
        if($customerSession->isLoggedIn() && $deviceTracking ) {
            $customerId = $customerSession->getCustomerId();
            $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
            $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
            $connection = $resource->getConnection();
            $sql = "SELECT * FROM ipqualityscore_devices WHERE user_id=" . $customerId;
            $query = $connection->prepare($sql);
            $query->execute();
            $device = $query->fetchAll(\PDO::FETCH_CLASS);
            if( !$device ){
                $trackingCode = $client->createDeviceTrackerUrl();
                echo $trackingCode;
                echo "<script defer>
                  Startup.AfterResult(function(result){
		      if( result.success ){
                      
		      result.uid = {$customerId};
                      
                      result.form_key = document.getElementsByName('form_key')[0].value;
                      var ajaxRequest = new XMLHttpRequest();
                      ajaxRequest.open('POST', 'ipqualityscore/index/device', true);
                      ajaxRequest.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
                      ajaxRequest.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
                      ajaxRequest.send('data=' + JSON.stringify(result),'form_key=' + document.getElementsByName('form_key')[0].value);
                      }
                  });
                </script>";
            }
        }
        */
        } catch (\Exception $e) {
            $this->logger->info($e->getMessage());
        }
    }
}
