<?php

namespace Ipqualityscore\Ipqualityscore\Events\Observer;

use Magento\Framework\Event\ObserverInterface;
use Psr\Log\LoggerInterface;

class SuccessOrder implements ObserverInterface
{
 protected $logger;
 protected $scopeConfig;

 public function __construct(LoggerInterface $logger,\Magento\Framework\App\RequestInterface $request, \Magento\Framework\View\Page\Config $pageConfig,  \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig ) {
     $this->logger = $logger;
     $this->_request = $request;
     $this->_page = $pageConfig;
     $this->scopeConfig = $scopeConfig;
 }

 public function execute(\Magento\Framework\Event\Observer $observer)
 {
    try {
        
        require_once dirname(__FILE__) . '/../../Integration.php';
        $isAuthed = $this->scopeConfig->getValue('ipqualityscore/general/auth_token',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
        if( $isAuthed ){
            $strictness = $this->scopeConfig->getValue('ipqualityscore/general/strictness',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $allowPublic = $this->scopeConfig->getValue('ipqualityscore/general/allow_public',\Magento\Store\Model\ScopeInterface::SCOPE_STORE)?true:false;
            $allowCrawlers = $this->scopeConfig->getValue('ipqualityscore/general/allow_crawlers',\Magento\Store\Model\ScopeInterface::SCOPE_STORE)?true:false;
            $blockScore = $this->scopeConfig->getValue('ipqualityscore/general/block_score',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
	    $redirect = $this->scopeConfig->getValue('ipqualityscore/general/redirect',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
	    $deviceTracking = $this->scopeConfig->getValue('ipqualityscore/general/enable_device_order',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $client = new \IpqualityScore\Integration($isAuthed, 'magentov2');
            $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
            $customerSession = $objectManager->get('Magento\Customer\Model\Session');
        
            if( $deviceTracking ) {
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                $storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
                $baseUrl = $storeManager->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_WEB);
                $orderIds = $observer->getEvent()->getOrderIds();
                $orderId = $orderIds[0];                
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
                $connection = $resource->getConnection();
                $sql = "SELECT * FROM ipqualityscore_devices WHERE order_id=?";
                $query = $connection->prepare($sql);
                $query->bindParam(1,$orderId);
                $query->execute();
                $device = $query->fetchAll(\PDO::FETCH_CLASS);
                if( !$device ){
                    $trackingCode = $client->createDeviceTrackerUrl();
                    echo $trackingCode;
                    echo "<script defer>
                      Startup.AfterResult(function(result){
		      if( result.success ){
		      result.oid = {$orderId};
                      result.form_key = document.getElementsByName('form_key')[0].value;
                      var ajaxRequest = new XMLHttpRequest();
                      ajaxRequest.open('POST', '{$baseUrl}ipqualityscore/index/device', true);
                      ajaxRequest.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
                      ajaxRequest.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
                      ajaxRequest.send('data=' + JSON.stringify(result),'form_key=' + document.getElementsByName('form_key')[0].value);
                      }
                  });
                </script>";
                }
            }
	}
    }catch (\Exception $e) {
        $this->logger->info($e->getMessage());
    }
 }
}
